## attachment.php?aid=MTg2OXwyYjRkYzk4MHwxNzY4ODE1MTIzfDU3MTZDM2lhZ2pXMkxMRWdpVUdubDhDUUFBRTZKTFNjWmpkZ1puN1VxaUNoWFJr

=== Makefile ===
include $(TOPDIR)/rules.mk

PKG_NAME:=snander
PKG_VERSION:=1.7.8
PKG_BUILD_DIR:=$(BUILD_DIR)/$(PKG_NAME)-$(PKG_VERSION)
PKG_BUILD_DEPENDS:=libpthread libusb-1.0
PKG_MAINTAINER:=McMCC <mcmcc@mail.ru>
PKG_LICENSE:=GPLv2.0
PKG_LICENSE_FILES:=LICENSE

include $(INCLUDE_DIR)/package.mk

define Package/$(PKG_NAME)
	SECTION:=utils
	CATEGORY:=Utilities
	TITLE:=Serial Nor/nAND/Eeprom programmeR (based on CH341A)
	MAINTAINER:=McMCC <mcmcc@mail.ru>
	URL:=https://github.com/McMCCRU/SNANDer
	DEPENDS:=+libpthread +libusb-1.0
	TARGET_CFLAGS:=-std=gnu99 -Wall -O2 -D_FILE_OFFSET_BITS=64
	TARGET_LDFLAGS:=-ldl -lpthread
endef

define Package/$(PKG_NAME)/description
	Serial Nor/nAND/Eeprom programmeR (based on CH341A)
endef

define Build/Prepare
	mkdir -p $(PKG_BUILD_DIR)
	cp -r src/* $(PKG_BUILD_DIR)
endef

define Package/$(PKG_NAME)/install
	$(INSTALL_DIR) $(1)/usr/bin
	$(INSTALL_BIN) $(PKG_BUILD_DIR)/snander $(1)/usr/bin
endef

$(eval $(call BuildPackage,$(PKG_NAME)))

=== src/Makefile ===
TARGET     = snander
PKG        = $(TARGET)
VERSION    = 1.7.8-1

CC        ?= gcc
STRIP     ?= strip
INSTALL   ?= install
WINDRES   ?= windres
PREFIX    ?= /usr
BINDIR    ?= $(PREFIX)/bin
CFLAGS    ?= -std=gnu99 -Wall -O2 -D_FILE_OFFSET_BITS=64
LDFLAGS   ?= -pthread
RES       ?= res.bin

EEPROM_SUPPORT = yes

SRCS = flashcmd_api.c spi_controller.c spi_nand_flash.c spi_nor_flash.c ch341a_spi.c timer.c main.c

ifdef LIBS_BASE
CFLAGS += -I$(LIBS_BASE)/include
LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
endif

ifeq ($(CONFIG_STATIC), yes)
LDFLAGS += -static
endif

ifeq ($(EEPROM_SUPPORT), yes)
CFLAGS += -DEEPROM_SUPPORT
SRCS += ch341a_i2c.c i2c_eeprom.c spi_eeprom.c bitbang_microwire.c mw_eeprom.c ch341a_gpio.c
endif

ifeq ($(TARGET_OS), MinGW)
EXEC_SUFFIX := .exe
SRCS += $(RES)
CFLAGS += -posix
CFLAGS += -Dffs=__builtin_ffs
CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
endif

ifeq ($(TARGET_OS), Darwin)
CFLAGS += -Wno-gnu-designator
LDFLAGS += -lobjc -Wl,-framework,IOKit -Wl,-framework,CoreFoundation -Wl,-framework,Security
endif

$(PKG): $(TARGET)$(EXEC_SUFFIX)

$(TARGET)$(EXEC_SUFFIX): $(SRCS)
	$(CC) $(CFLAGS) $(SRCS) $(LDFLAGS) -lusb-1.0 -o $@

$(RES):
	$(WINDRES) -i $(TARGET).rc -o $@

clean: 
	rm -f $(TARGET)$(EXEC_SUFFIX) $(RES)

strip: $(TARGET)$(EXEC_SUFFIX)
	$(STRIP) $(TARGET)$(EXEC_SUFFIX)

install: $(TARGET)
	mkdir -p $(DESTDIR)$(BINDIR)
	mkdir -p $(DESTDIR)/etc/udev/rules.d
	$(INSTALL) -m 0755 $(TARGET) $(DESTDIR)$(BINDIR)
	$(INSTALL) -m 0664 40-persistent-ch341a.rules $(DESTDIR)/etc/udev/rules.d/40-persistent-ch341a.rules

install-udev-rule:
	cp 40-persistent-ch341a.rules /etc/udev/rules.d/
	udevadm control --reload-rules
.PHONY: clean install-udev-rule

debian/changelog:
	dch --create -v $(VERSION) --package $(PKG)

deb:
	dpkg-buildpackage -b -us -uc
.PHONY: install debian/changelog deb

=== src/debian/changelog ===
snander (1.7.8-1) UNRELEASED; urgency=medium

  * Update libusb version to v1.0.26.
  * Add -k option to skip BAD blocks or pages when reading and writing NAND flash.
  * Add P25D05H/P25D10H/P25D20H/P25D40H/P25D80H/PY25Q128HA SPI NOR Flash support.
  * Add NM25Q32E/NM25Q64E/NM25Q128E/NM25L256F SPI NOR Flash support.
  * Add FORESEE FS35ND01GS1Y2 SPI NAND Flash support.
  * Add DS DS35M1GA/DS35M2GA SPI NAND Flash support.
  * Add ESMT F50D1G41LB(2M) SPI NAND Flash support.
  * Add MXIC MX35LF2G14AC SPI NAND Flash support.
  * Add WINBOND W25N01GW SPI NAND Flash support.
  * Fix when SPI_NAND_FLASH_DEBUG is enabled.

 -- McMCC <mcmcc@mail.ru>  Mon, 5 Jun 2023 10:36:12 +0800

=== src/debian/control ===
Source: snander
Priority: optional
Maintainer: McMCC <mcmcc@mail.ru>
Build-Depends: debhelper (>= 9)
Standards-Version: 1.7.8
Section: electronics
Vcs-Git: https://github.com/McMCCRU/SNANDer.git
Vcs-Browser: https://github.com/McMCCRU/SNANDer

Package: snander
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SNANDer - Serial Nor/nAND/Eeprom programmeR (based on CH341A)

=== src/debian/rules ===
#!/usr/bin/make -f

export DEB_CFLAGS_SET = -std=gnu99 -Wall -O2 -D_FILE_OFFSET_BITS=64
export DEB_LDFLAGS_SET = -pthread

%:
	dh $@

override_dh_auto_install:
	$(MAKE) install DESTDIR=$(PWD)/debian/snander prefix=/usr

override_dh_usrlocal:
